#Plug in to get typing mode (english and vietnamese) of unikey and vietkey 
# Author: Dung Nguyen <dungnv1984@gmail.com>
# Date: December 2013
# Key combination:  Control + Alt  + z   to get cuent mode of typing
# and Alt  + Z to switch  on/off vietnamese typing mode

import globalPluginHandler
import globalVars
import ui
import ctypes
import NVDAObjects
import time
import speech
import os.path

encoding = "utf8"
messageFile = "vnKeyMessages.ini"
vnOn = "vnOn"
vnOff = "vnOff"
enOn = "enOn"
enOff = "enOff"
empty = ""
class GlobalPlugin (globalPluginHandler.GlobalPlugin):
	#ui.message("Build successfully")
	# Binding a key for script
	__gestures={"kb:Control+Alt+z": "getVNKeyInfo",
		"kb:alt+z": "switchVNKey",
		}

	#define a script to check unikey and vietkey programs is running or not
	# and infom to use the status (vietnamese on/off/not running
	def script_getVNKeyInfo(self, gesture):
		self.getInfo()
		
	# switch  vietnamese  input type on/off and inform to user
	def script_switchVNKey(self, gesture):
		# send key to application 
		gesture.send()
		time.sleep(0.5)
		self.getInfo()
	
	#get current input typing mode (english or vietnamese)
	def getInfo(self):
		vietkeyOn = "mode:"
		vietkeyOff = "vietkey"
		unikeyOn = "turn off"
		unikeyOff = "turn on"
		
		# get current synthesizer
		currentSynth = speech.getSynth().name
		statusOn = ""
		statusOff = ""
		if currentSynth == "sapi5":
			statusOn = vnOn
			statusOff = vnOff
		else:
			statusOn = enOn
			statusOff = enOff
		
		#get all objects in system tray
		l=("shell_TrayWnd","TrayNotifyWnd","SysPager","ToolbarWindow32")
		h,FindWindowExA =0,ctypes.windll.user32.FindWindowExA
		for element in l:
			h = FindWindowExA(h,0,element,0)
			
		o = NVDAObjects.IAccessible.getNVDAObjectFromEvent(h,-4,1)
		while o is not None:
			name = o.name.lower()
			#check current status
			if name.find(vietkeyOff) is not  -1:
				ui.message(self.getMessage(statusOff))
				break
			if name.find(vietkeyOn) is not -1:
				ui.message(self.getMessage(statusOn))
				break
			if name.find(unikeyOn) is not -1:
				ui.message(self.getMessage(statusOn))
				break
			if name.find(unikeyOff) is not -1:
				ui.message(self.getMessage(statusOff))
				break
			# move to next icon on  system tay				
			o = o.next
	
	def getMessage(self, status):
		fileName = self.getVoicePath() + messageFile
		message = self.iniReadString(status, fileName)
		return message
		
	def getVoicePath(self):
		return globalVars.appArgs.configPath + "\\addons\\switchVNSynth\\globalPlugins\\vnVoices\\"

	def iniReadString(self, key, fileName):
		if  key == empty or fileName == empty :
			return empty
		if not os.path.isfile(fileName) :
			log.info( "file: " + fileName + " does not exist")
			return empty
		file = open(fileName, "r")
		content = file.read().decode(encoding)
		file.close()
		s = key + "="
		start = content.find(s)
		if start == -1 :
			return empty
		content = content [start:]
		end = content.find("\n")
		if end > 0 :
			content = content[:end]
		start = content.find("=")
		content = content[start+1 :]
		content = content.strip()
		return content